﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private Const WebServiceEstados As String = "https://servicodados.ibge.gov.br/api/v1/localidades/estados"
	
	Type EstadoInfo(ID As Int, Nome As String, sigla As String)	
	
	Private Estados As List	
	
	Private objViaCep As ViaCep
	
	' As variáveis abaixo serve pra armazenar os valores selecionados pelo usuário
	' toda vez que a atividade é criada ou retomada.
	Private estado As String
	Private cidade As String
	Private logradouro As String
	
	Public pesquisaResultado As List

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private btnBuscar As Button
	Private lvwEnderecoCep As ListView
	Private spnUF As Spinner
	Private txtLogradouro As EditText
	Private txtCidadeComplete As AutoCompleteEditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Activity.LoadLayout("cep_da_rua_layout")
	
	'
	' Carrega o spinnerButton com todos os estados do Brasil.
	'
	ibgeDB.GetIbgeEstadoSiglas(spnUF)	
	
	
	Dim estadoSigla As String = spnUF.GetItem(0).SubString2(0, 2)
	spnUF.SelectedIndex = 0
	
	ibgeDB.GetIbgeCompletarCidades(txtCidadeComplete, estadoSigla)
	
	' Desativa o controle de buscar cep, pois devemos ter todos os campos preenchidos.
	btnBuscar.Enabled = False
	
	spnUF.SelectedIndex = spnUF.IndexOf("MG - Minas Gerais")
	txtCidadeComplete.Text = "Ribeirão das Neves"
	txtLogradouro.Text = "anton"
	
	estado = spnUF.SelectedItem
	cidade = txtCidadeComplete.Text
	logradouro = txtLogradouro.Text
	
	objViaCep.Initialize
	
	
End Sub

Sub Activity_Resume
	' Quando a atividade retorna, devemos retorna quais foram os valores escolhidos
	' pelo usuário anteriormente.
	Dim indice As Long
	indice = spnUF.IndexOf(estado)
	spnUF.SelectedIndex = indice
	
	txtCidadeComplete.Text = cidade
	txtLogradouro.Text = logradouro
	
	txtCidadeComplete.Text = "Ribeirão das Neves"
	txtLogradouro.Text = "anton"
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	estado = spnUF.SelectedItem
	cidade = txtCidadeComplete.text
	logradouro = txtLogradouro.text
		
End Sub

Sub txtLogradouro_TextChanged (Old As String, New As String)
	btnBuscar.Enabled = New.Length >= 4 And txtCidadeComplete.Text.Length >= 4	
End Sub

Sub txtLogradouro_EnterPressed
	
End Sub

Sub spnUF_ItemClick (Position As Int, Value As Object)
	' No spinner, a sigla é as duas primeiras letras.
	Dim estadoSigla As String = spnUF.GetItem(Position).SubString2(0, 2)
	
	' Iremos passar a sigla pra a função abaixo, pois, irá preencher
	' o controle 'Compl
	ibgeDB.GetIbgeCompletarCidades(txtCidadeComplete, estadoSigla)
	txtCidadeComplete.Text = ""
End Sub

Sub lvwEnderecoCep_ItemClick (Position As Int, Value As Object)
	
End Sub

Sub btnBuscar_Click
	' Vamos conectar no webservice e obter os dados.
	Dim siglaEstado As String = spnUF.SelectedItem.SubString2(0, 2)
	Dim cidade As String = txtCidadeComplete.Text
	Dim logradouro As String = txtLogradouro.Text
	
	ProgressDialogShow2("Pesquisando, aguarde...", False)
	
	Wait For (objViaCep.ObterCepDoEndereco(siglaEstado, cidade, logradouro)) Complete (listaRetorno As List)
		
	' Quando a função retorna, se houver erro, haverá na lista
	' um único ítem do tipo 'viaCepTipo', e no campo 'erro', 
	' indicará se houve erro.
	Dim objViaCepTipo As ViaCepTipo
	If listaRetorno.Size = 1 Then
		objViaCepTipo = listaRetorno.Get(0)
		If objViaCepTipo.error.IsError Then
			lvwEnderecoCep.Clear
			ProgressDialogHide
			ToastMessageShow(objViaCepTipo.error.ErrorMsg, True)
			Return			
		End If
	End If	
	
	If listaRetorno.Size = 0 Then
		lvwEnderecoCep.Clear	
		ToastMessageShow("Nenhum registro localizado.", True)
		ProgressDialogHide
		Return
	End If
	
	Dim listaViaCepTipo As List = listaRetorno
	listaViaCepTipo.SortType("logradouro", True)
	
	lvwEnderecoCep.Clear	
	'lvwEnderecoCep.TwoLinesLayout.SecondLabel.SingleLine=True
	'lvwEnderecoCep.TwoLinesLayout.SecondLabel.Height = 50dip
	
	ProgressDialogHide()
	
	pesquisaResultado = listaViaCepTipo
	
	StartActivity(PesquisaResultadoActivity)
		
	#if 0		
	For Each objViaCepTipo As ViaCepTipo In listaViaCepTipo		
		If objViaCepTipo.logradouro = "" Then
			lvwEnderecoCep.AddSingleLine2(objViaCepTipo.localidade, objViaCepTipo)
		Else
			lvwEnderecoCep.AddTwoLines2("Bairro: " & objViaCepTipo.bairro, _
				"Rua: " & objViaCepTipo.logradouro, objViaCepTipo)
		End If
	Next
	
	
	ProgressDialogHide()
	#end if
		
End Sub

Sub spnCidade_ItemClick (Position As Int, Value As Object)
	
End Sub

Sub txtCidadeComplete_ItemClick (Value As String)
		
End Sub

Sub txtCidadeComplete_TextChanged (Old As String, New As String)
	btnBuscar.Enabled = New.Length >= 4 And txtLogradouro.Text.Length >= 4
End Sub

Sub txtCidadeComplete_EnterPressed
	
End Sub

Sub txtCidadeComplete_FocusChanged (HasFocus As Boolean)
	
End Sub