﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private const IBGE_ESTADOS As String = "https://servicodados.ibge.gov.br/api/v1/localidades/estados"
	Private CONST IBGE_CIDADES As String = "https://servicodados.ibge.gov.br/api/v1/localidades/municipios"
	
	Type IbgeEstado (id As Long, nome As String, sigla As String, regiao_id As Long)
	Type IbgeCidade (id As Long, nome As String, uf_id As Long)
	
	'Type IbgeCidade (id As Long, nome As String, microrregiao_id As Long, mesorregiao_id As Long, uf_id As Long, regiao_id As Long)
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

' 
' Converte o json retornado do webservice em 
' uma lista do tipo 'IbgeEstado'
'
Private Sub JsonToListIbgeEstado(Json As String) As List
	Dim listaIbgeEstados As List
	listaIbgeEstados.Initialize
	
	Dim parser As JSONParser
	parser.Initialize(Json)
	Dim root As List = parser.NextArray
		
	For Each colroot As Map In root
		Dim objIbgeEstado As IbgeEstado
		objIbgeEstado.Initialize
						
		objIbgeEstado.sigla = colroot.Get("sigla")
		objIbgeEstado.nome = colroot.Get("nome")
		objIbgeEstado.id = colroot.Get("id")
			
		Dim regiao As Map = colroot.Get("regiao")
		objIbgeEstado.regiao_id = regiao.Get("id")
			
		listaIbgeEstados.Add(objIbgeEstado)			
	Next
	
	Return listaIbgeEstados
End Sub

Private Sub JsonToListIbgeCidade(Json As String) As List
	Dim listaIbgeCidades As List
	listaIbgeCidades.Initialize
		
	Dim parser As JSONParser
	parser.Initialize(Json)

	Dim root As List = parser.NextArray
	For Each colroot As Map In root
		Dim objIbgeCidade As IbgeCidade
		
		objIbgeCidade.id = colroot.Get("id")
		objIbgeCidade.nome = colroot.Get("nome")
		
		Dim microrregiao As Map = colroot.Get("microrregiao")
		Dim mesorregiao As Map = microrregiao.Get("mesorregiao")
		Dim UF As Map = mesorregiao.Get("UF")
		
		objIbgeCidade.uf_id = UF.Get("id")
		
		listaIbgeCidades.Add(objIbgeCidade)		
	Next
	
	Return listaIbgeCidades
	
End Sub

' 
' Retorna do webservice após converter o json, uma lista
' do tipo 'IbgeEstado'.
'
Public Sub GetIbgeEstados() As ResumableSub
	Dim objHttp As HttpJob
	objHttp.Initialize("", Me)
	
	objHttp.Download(IBGE_ESTADOS)
	Wait For (objHttp) JobDone(objHttp As HttpJob)
	If objHttp.Success Then
		Dim listaIbgeEstado As List = JsonToListIbgeEstado(objHttp.GetString)		
		objHttp.Release
		Return listaIbgeEstado		
	Else
		objHttp.Release
		Return Null
	End If	
	
End Sub

'
' Retorna do webservice todas as cidades do Brazil.
'
Public Sub GetIbgeCidades() As ResumableSub
	
	Dim objHttp As HttpJob
	
	objHttp.Initialize("", Me)
	objHttp.Download(IBGE_CIDADES)
	Wait For (objHttp) JobDone(objHttp As HttpJob)
	If objHttp.Success Then
		Dim listaIbgeCidade As List = JsonToListIbgeCidade(objHttp.GetString)
		objHttp.Release
		Return listaIbgeCidade		
	Else
		objHttp.Release
		Return Null		
	End If
	
End Sub



