﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

' 
' Obtém a letra inicial de cada cidade de um estado específico.
' 
Public Sub GetIbgeCidadeLetraInicial(objSpinner As Spinner, estado_sigla As String)
	Dim objSql As SQL = Starter.objSql
	Dim sqlCursor As Cursor
	
	objSpinner.Clear
	If estado_sigla.Trim() = "" Then
		Return
	End If
	
	sqlCursor = objSql.ExecQuery($"Select distinct substr(ibge_municipios.nome, 1, 3) as municipio_nome from ibge_uf, ibge_municipios
		where ibge_uf.id = ibge_municipios.uf_id
		and ibge_uf.sigla = '${estado_sigla}'
		 order by ibge_municipios.nome	
	"$)
	For uA = 0 To sqlCursor.RowCount - 1
		sqlCursor.Position = uA
		objSpinner.Add(sqlCursor.GetString("municipio_nome"))
	Next
	objSpinner.SelectedIndex = 0
	sqlCursor.Close
End Sub


Public Sub GetIbgeEstadoSiglas(objSpinner As Spinner)
	Dim objSql As SQL = Starter.objSql
	Dim sqlCursor As Cursor
	
	sqlCursor = objSql.ExecQuery("Select sigla, nome from ibge_uf order by sigla asc")
	
	objSpinner.Clear
	For uA = 0 To sqlCursor.RowCount - 1
		sqlCursor.Position = uA
		objSpinner.Add(sqlCursor.GetString("sigla") & " - " & sqlCursor.GetString("nome"))		
	Next
	sqlCursor.Close	
	
End Sub

'
' Preenche o spinner com todas as cidades, conforme o estado
' escolhido.
'
Public Sub GetIbgeCidades(objSpinner As Spinner, estado_sigla As String)
	Dim objSql As SQL = Starter.objSql
	Dim sqlCursor As Cursor
	
	objSpinner.Clear
	If estado_sigla.Trim() = "" Then
		Return
	End If
	
	sqlCursor = objSql.ExecQuery($"Select ibge_municipios.nome as municipio_nome from ibge_uf, ibge_municipios
		where ibge_uf.id = ibge_municipios.uf_id
		and ibge_uf.sigla = '${estado_sigla}'
		 order by ibge_municipios.nome	
	"$)
	For uA = 0 To sqlCursor.RowCount - 1
		sqlCursor.Position = uA
		objSpinner.Add(sqlCursor.GetString("municipio_nome"))
	Next
	objSpinner.SelectedIndex = 0
	sqlCursor.Close
	
End Sub

Public Sub GetIbgeCompletarCidades(txtCidade As AutoCompleteEditText, estado_sigla As String)
	Dim objSql As SQL = Starter.objSql
	Dim sqlCursor As Cursor	
	
	If estado_sigla.Trim() = "" Then
		Return
	End If
	
	sqlCursor = objSql.ExecQuery($"Select ibge_municipios.nome as municipio_nome from ibge_uf, ibge_municipios
		where ibge_uf.id = ibge_municipios.uf_id
		and ibge_uf.sigla = '${estado_sigla}'
		 order by ibge_municipios.nome	
	"$)
	
	Dim lista_de_cidades As List
	lista_de_cidades.Initialize
	
	For uA = 0 To sqlCursor.RowCount - 1
		sqlCursor.Position = uA
		lista_de_cidades.Add(sqlCursor.GetString("municipio_nome"))
	Next
	lista_de_cidades.Sort(True)
	txtCidade.SetItems(lista_de_cidades)
	
	sqlCursor.Close
	
End Sub


Public Sub GetIbgeCidadesporLetraInicial(objSpinner As Spinner, estado_sigla As String, letra_inicial As String)
	Dim objSql As SQL = Starter.objSql
	Dim sqlCursor As Cursor
	
	objSpinner.Clear
	If estado_sigla.Trim() = "" Then
		Return
	End If
	
	sqlCursor = objSql.ExecQuery($"Select ibge_municipios.nome as municipio_nome from ibge_uf, ibge_municipios
		where ibge_uf.id = ibge_municipios.uf_id
		and ibge_uf.sigla = '${estado_sigla}'
		and substr(ibge_municipios.nome, 1, Length('${letra_inicial}')) = '${letra_inicial}'
		 order by ibge_municipios.nome	
	"$)
	For uA = 0 To sqlCursor.RowCount - 1
		sqlCursor.Position = uA
		objSpinner.Add(sqlCursor.GetString("municipio_nome"))
	Next
	objSpinner.SelectedIndex = 0
	sqlCursor.Close	
	
End Sub